/*----- PROTECTED REGION ID(CanberraAIM556.h) ENABLED START -----*/
//=============================================================================
//
// file :        CanberraAIM556.h
//
// description : Include file for the CanberraAIM556 class
//
// project :     MCA Canberra AIM 556
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef CanberraAIM556_H
#define CanberraAIM556_H

#include <tango.h>
#include "AIM556.h"


/*----- PROTECTED REGION END -----*/	//	CanberraAIM556.h

/**
 *  CanberraAIM556 class description:
 *    A class to control the MCA Canberra AIM 556 (A ou B).
 */

namespace CanberraAIM556_ns
{
enum _ModeEnum {
	_PHA,
	_MCS,
	_LIST,
} ;
typedef _ModeEnum ModeEnum;

/*----- PROTECTED REGION ID(CanberraAIM556::Additional Class Declarations) ENABLED START -----*/

//	Additional Class Declarations

/*----- PROTECTED REGION END -----*/	//	CanberraAIM556::Additional Class Declarations

class CanberraAIM556 : public TANGO_BASE_CLASS
{

/*----- PROTECTED REGION ID(CanberraAIM556::Data Members) ENABLED START -----*/

//	Add your own data members
	AIM556 *aim;

	void SetupMCA();
  bool InitSetPoint(string attName,double *value);

/*----- PROTECTED REGION END -----*/	//	CanberraAIM556::Data Members

//	Device property data members
public:
	//	Address:	Address suffix of the AIM. (Eg. 0x08E0)
	string	address;
	//	Interface:	Network interface name (eg. eth0)
	string	interface;

//	Attribute data members
public:
	Tango::DevShort	*attr_ADC_read;
	ModeEnum	*attr_Mode_read;
	Tango::DevULong	*attr_Channels_read;
	Tango::DevDouble	*attr_PresetLiveTime_read;
	Tango::DevDouble	*attr_PresetRealTime_read;
	Tango::DevDouble	*attr_LiveTime_read;
	Tango::DevDouble	*attr_RealTime_read;
	Tango::DevULong	*attr_Data_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	CanberraAIM556(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	CanberraAIM556(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	CanberraAIM556(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~CanberraAIM556() {delete_device();};


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Read the device properties from database
	 */
	void get_device_property();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();


//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method      : CanberraAIM556::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(vector<long> &attr_list);
	//--------------------------------------------------------
	/*
	 *	Method      : CanberraAIM556::write_attr_hardware()
	 *	Description : Hardware writing for attributes.
	 */
	//--------------------------------------------------------
	virtual void write_attr_hardware(vector<long> &attr_list);

/**
 *	Attribute ADC related methods
 *	Description: ADC index (0..1)
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
	virtual void read_ADC(Tango::Attribute &attr);
	virtual void write_ADC(Tango::WAttribute &attr);
	virtual bool is_ADC_allowed(Tango::AttReqType type);
/**
 *	Attribute Mode related methods
 *	Description: Acquisition Mode
 *               0 -> PHA
 *               1 -> PHA LFC
 *               2 -> DBL BUFFERS
 *
 *	Data type:	Tango::DevEnum
 *	Attr type:	Scalar
 */
	virtual void read_Mode(Tango::Attribute &attr);
	virtual void write_Mode(Tango::WAttribute &attr);
	virtual bool is_Mode_allowed(Tango::AttReqType type);
/**
 *	Attribute Channels related methods
 *	Description: Channel number
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
	virtual void read_Channels(Tango::Attribute &attr);
	virtual void write_Channels(Tango::WAttribute &attr);
	virtual bool is_Channels_allowed(Tango::AttReqType type);
/**
 *	Attribute PresetLiveTime related methods
 *	Description: Preset live time
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_PresetLiveTime(Tango::Attribute &attr);
	virtual void write_PresetLiveTime(Tango::WAttribute &attr);
	virtual bool is_PresetLiveTime_allowed(Tango::AttReqType type);
/**
 *	Attribute PresetRealTime related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_PresetRealTime(Tango::Attribute &attr);
	virtual void write_PresetRealTime(Tango::WAttribute &attr);
	virtual bool is_PresetRealTime_allowed(Tango::AttReqType type);
/**
 *	Attribute LiveTime related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_LiveTime(Tango::Attribute &attr);
	virtual bool is_LiveTime_allowed(Tango::AttReqType type);
/**
 *	Attribute RealTime related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_RealTime(Tango::Attribute &attr);
	virtual bool is_RealTime_allowed(Tango::AttReqType type);
/**
 *	Attribute Data related methods
 *	Description: 
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Spectrum max = 65536
 */
	virtual void read_Data(Tango::Attribute &attr);
	virtual bool is_Data_allowed(Tango::AttReqType type);


	//--------------------------------------------------------
	/**
	 *	Method      : CanberraAIM556::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:
	/**
	 *	Command State related method
	 *	Description: This command gets the device state (stored in its device_state data member) and returns it to the caller.
	 *
	 *	@returns Device state
	 */
	virtual Tango::DevState dev_state();
	/**
	 *	Command On related method
	 *	Description: Start the aquisition
	 *
	 */
	virtual void on();
	virtual bool is_On_allowed(const CORBA::Any &any);
	/**
	 *	Command Off related method
	 *	Description: Stop the acquistion
	 *
	 */
	virtual void off();
	virtual bool is_Off_allowed(const CORBA::Any &any);
	/**
	 *	Command Reset related method
	 *	Description: Clear memory
	 *
	 */
	virtual void reset();
	virtual bool is_Reset_allowed(const CORBA::Any &any);
	/**
	 *	Command ClearMemory related method
	 *	Description: Reset the acquisition memory to 0
	 *
	 */
	virtual void clear_memory();
	virtual bool is_ClearMemory_allowed(const CORBA::Any &any);


	//--------------------------------------------------------
	/**
	 *	Method      : CanberraAIM556::add_dynamic_commands()
	 *	Description : Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(CanberraAIM556::Additional Method prototypes) ENABLED START -----*/

//	Additional Method prototypes

/*----- PROTECTED REGION END -----*/	//	CanberraAIM556::Additional Method prototypes
};

/*----- PROTECTED REGION ID(CanberraAIM556::Additional Classes Definitions) ENABLED START -----*/

//	Additional Classes Definitions

/*----- PROTECTED REGION END -----*/	//	CanberraAIM556::Additional Classes Definitions

}	//	End of namespace

#endif   //	CanberraAIM556_H
